libname daruo 'C:\QE_MS_1528';run;


data data02; 
set daruo.monthly_data_sw;
date=mdy(month,01,year);
format date mmddyy6.;
run;

proc sort data=data02; 
by firm_month date;
run;

data data03;
set data02;
if lag(firm_month)=firm_month then mv_lag = lag(mv);
else mv_lag=.;
if mv_lag^=.;
run;

**********************************************************************************************;
data mkt;
set data03;
if mv_lag^=.;
keep date ret_us mv_lag;run;

data riskfree_rate;
set daruo.ff4_monthly;
keep date rf;
run;

proc sort data=mkt;
by date;
run;

data mkt01;
merge mkt riskfree_rate;
by date;
if ret_us^=.;
mkt_excess = ret_us - rf/100;
run;


proc means data=mkt01 noprint;
by date;
var mkt_excess;
weight mv_lag;
output out=mkt02 mean=mkt;
run;

data daruo.monthly_mkt_factor;
set mkt02;
numfirm=_FREQ_;
keep date mkt;
run;

**********************************************************************************************;
