
libname folder 'C:\QE_MS_1528';run;


data try001;
set folder.reg_results_2ew_ratio;  *input FM reg slopes data set;
if year(date3)<=2014;
run;

 proc model data=try001;
         endo slope_ivol;
         instruments / intonly;
         parms b0;
         slope_ivol = b0;
         fit slope_ivol / gmm kernel=(bart,4,0) vardef=n;
         run; 

proc model data=try001;
         endo slope_beta;
         instruments / intonly;
         parms b0;
         slope_beta = b0;
         fit slope_beta / gmm kernel=(bart,4,0) vardef=n;
         run; 


**********************************;

data try002;
set folder.reg_results_2vw_ivol;  *input FM reg slopes data set;
if year(date3)<=2014;
run;

 proc model data=try002;
         endo slope_ivol;
         instruments / intonly;
         parms b0;
         slope_ivol = b0;
         fit slope_ivol / gmm kernel=(bart,4,0) vardef=n;
         run; 

proc model data=try002;
         endo slope_beta;
         instruments / intonly;
         parms b0;
         slope_beta = b0;
         fit slope_beta / gmm kernel=(bart,4,0) vardef=n;
         run; 

**********************************;
**********************************;
		 

data try003;
set folder.reg_results_2ew_ratio_ew;  *input FM reg slopes data set;
if year(date3)<=2014;
run;

 proc model data=try003;
         endo slope_ivol;
         instruments / intonly;
         parms b0;
         slope_ivol = b0;
         fit slope_ivol / gmm kernel=(bart,4,0) vardef=n;
         run; 

proc model data=try003;
         endo slope_beta;
         instruments / intonly;
         parms b0;
         slope_beta = b0;
         fit slope_beta / gmm kernel=(bart,4,0) vardef=n;
         run; 


**********************************;

data try004;
set folder.reg_results_2vw_ivol_ew;  *input FM reg slopes data set;
if year(date3)<=2014;
run;

 proc model data=try004;
         endo slope_ivol;
         instruments / intonly;
         parms b0;
         slope_ivol = b0;
         fit slope_ivol / gmm kernel=(bart,4,0) vardef=n;
         run; 

proc model data=try004;
         endo slope_beta;
         instruments / intonly;
         parms b0;
         slope_beta = b0;
         fit slope_beta / gmm kernel=(bart,4,0) vardef=n;
         run; 

**********************************;
**********************************;
		 

data try005;
set folder.reg_results_2ew_ratio_vw;  *input FM reg slopes data set;
if year(date3)<=2014;
run;

 proc model data=try005;
         endo slope_ivol;
         instruments / intonly;
         parms b0;
         slope_ivol = b0;
         fit slope_ivol / gmm kernel=(bart,4,0) vardef=n;
         run; 

proc model data=try005;
         endo slope_beta;
         instruments / intonly;
         parms b0;
         slope_beta = b0;
         fit slope_beta / gmm kernel=(bart,4,0) vardef=n;
         run; 


**********************************;

data try006;
set folder.reg_results_2vw_ivol_vw;  *input FM reg slopes data set;
if year(date3)<=2014;
run;

 proc model data=try006;
         endo slope_ivol;
         instruments / intonly;
         parms b0;
         slope_ivol = b0;
         fit slope_ivol / gmm kernel=(bart,4,0) vardef=n;
         run; 

proc model data=try006;
         endo slope_beta;
         instruments / intonly;
         parms b0;
         slope_beta = b0;
         fit slope_beta / gmm kernel=(bart,4,0) vardef=n;
         run; 

