
libname folder 'C:\QE_MS_1528';run;


data try001;
set folder.reg_results_2vw_ratio;  *input FM reg slopes data set;
if year(date3)<=2014;
if year(date3)>=1990;
run;


data try000;
set try001; 
run;

 proc model data=try000;
         endo slope_ivol;
         instruments / intonly;
         parms b0;
         slope_ivol = b0;
         fit slope_ivol / gmm kernel=(bart,4,0) vardef=n;
         run; 

proc model data=try000;
         endo slope_beta;
         instruments / intonly;
         parms b0;
         slope_beta = b0;
         fit slope_beta / gmm kernel=(bart,4,0) vardef=n;
         run; 
